﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace SlowGdi {
	public partial class SlowGdiForm : Form {

		private Random RandomSource = new Random();

		private int[] RandomPixels = new int[512 * 512];

		private Bitmap RandomBitmap = new Bitmap(512, 512);

		public SlowGdiForm() {
			InitializeComponent();
			this.SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque | ControlStyles.UserPaint | ControlStyles.OptimizedDoubleBuffer, true);
			this.Disposed += (sender, e) => this.RandomBitmap.Dispose();
			Application.Idle += (sender, e) => this.Invalidate();
		}


		protected override void OnPaint(PaintEventArgs e) {
			for (int i = 0; i < RandomPixels.Length; i++) {
				this.RandomPixels[i] = this.RandomSource.Next();
			}
			var Locked = this.RandomBitmap.LockBits(new Rectangle(0, 0, 512, 512), ImageLockMode.WriteOnly, PixelFormat.Format32bppRgb);
			Marshal.Copy(this.RandomPixels, 0, Locked.Scan0, 512 * 512);
			this.RandomBitmap.UnlockBits(Locked);
			e.Graphics.DrawImage(this.RandomBitmap, 0, 0, this.ClientSize.Width, this.ClientSize.Height);
		}

	}
}
